{ Unit:            linlist2.pas
  Autor:           Sascha Nemecek
  Matrikelnr.:     9825815
  Erstellt am:     17.04.1999
  Letzte nderung: 19.04.1999

  Kurzbeschreibung:
  Ermglicht die Verwendung einer einfach verketteten Liste, in der
  beliebige Pointer gespeichert werden knnen.
  }


UNIT linlist2;



INTERFACE

{ Typen definitionen }
TYPE

{ Definition eines Knotens der einfach verketteten Liste. }
KnotenPtr = ^Knoten;
Knoten = OBJECT
     next: KnotenPtr;
     data: pointer;
END;

{ Definition der Klasse verkettete Liste. }
ListePtr = ^Liste;
Liste = OBJECT
     start, now: KnotenPtr;
     CONSTRUCTOR Init;
     PROCEDURE addElement (d : pointer);
     PROCEDURE clearList;
     PROCEDURE gotoEnd;
     PROCEDURE gotoNext;
     PROCEDURE gotoStart;
     PROCEDURE removeElement;
     FUNCTION eol : boolean;
     FUNCTION getData : pointer;
     FUNCTION IsEmpty : boolean;
     FUNCTION NumberOfElements : Integer;
     DESTRUCTOR done;
END;




IMPLEMENTATION


{ Constructor Init.
  Setzt alle Anfangswerte. }
CONSTRUCTOR Liste.Init;
BEGIN
     start := NIL;
     now := NIL;
END;



{ Procedure addElement ().
  Fgt ein neues Element am Ende der Liste ein.
  @param d Der einzufgende Datenwert. }
PROCEDURE Liste.addElement (d : pointer);
VAR hptr: KnotenPtr;
BEGIN
     new (hptr);
     hptr^.data := d;
     hptr^.next := NIL;

     { Wenn die Liste nicht leer ist. }
     IF isEmpty = FALSE THEN BEGIN
        gotoEnd;
        now^.next := hptr;
     END ELSE
        start := hptr
END;



{ Prozedur clearList.
  Lscht die gesamte Liste. }
PROCEDURE Liste.clearList;
BEGIN
     IF IsEmpty = TRUE THEN
        EXIT;
     gotoStart;
     WHILE IsEmpty = false DO
           removeElement
END;



{ Prozedur gotoEnd.
  Setzt den now Pointer auf das Ende der Liste. }
PROCEDURE Liste.gotoEnd;
BEGIN
     now := start;
     IF IsEmpty = TRUE THEN
        EXIT;
     WHILE now^.next <> NIL DO
           now := now^.next
END;



{ Prozedur gotoNext.
  Setzt den now Pointer auf das nchste Element in der Liste. }
PROCEDURE Liste.gotoNext;
BEGIN
     IF now = NIL THEN
        exit;
{     IF now^.next = NIL THEN
        exit;}
     now := now^.next;
END;



{ Prozedur gotoStart.
  Setzt den now Pointer auf den Anfang der Liste. }
PROCEDURE Liste.gotoStart;
BEGIN
     now := start;
END;



{ Prozedur removeElement.
  Lscht das aktuelle Element aus der Liste. }
PROCEDURE Liste.removeElement;
VAR h : KnotenPtr;
BEGIN
     IF (start = NIL) or (now = NIL) THEN
        exit;

     IF now <> start THEN

     { Das nicht-erste Element wird gelscht. }
     BEGIN
          h := start;
          WHILE h^.next <> now DO h := h^.next;
          h^.next := now^.next;
          dispose (now);
          now := h;

     { Das erste Element der Liste wird gelscht. }
     END ELSE BEGIN
          start := now^.next;
          dispose (now);
          now := start;
     END
END;



{ Function eol.
  berprft ob der now Pointer auf das letzte Element zeigt.
  @return TRUE, falls das Ende der Liste erreicht wurde. }
FUNCTION Liste.eol : boolean;
VAR e: boolean;
BEGIN
     e := FALSE;
     IF now = NIL THEN e := TRUE;
{     IF now^.next = NIL THEN
        e := TRUE;}
     eol := e;
END;



{ Prozedur getData.
  Liefert den Inhalt des aktuellen Elements.
  Keine berprfung ob berhaupt ein Element existiert.
  @return Inhalt des Datenelements. }
FUNCTION Liste.getData : pointer;
BEGIN
     IF IsEmpty = TRUE THEN
        getdata := NIL
     ELSE
        getData := now^.data;
END;



{ Function IsEmpty.
  berprft ob die Liste leer ist.
  @return True = leer; False = nicht leer. }
FUNCTION Liste.IsEmpty : boolean;
BEGIN
     IF start = NIL THEN
        IsEmpty := TRUE
     ELSE
        IsEmpty := FALSE;
END;



{ Function NumberOfElements.
  Zhlt die Elemente in der Liste.
  @return Anzahl der Elemente in der Liste. }
FUNCTION Liste.NumberOfElements : Integer;
VAR i : integer;
BEGIN
     i := 1;
     gotoStart;
     IF now = NIL THEN
         i := 0
     ELSE
        WHILE now^.next <> NIL DO
        BEGIN
           i := i + 1;
           now := now^.next;
        END;
     NumberOfElements := i;
     gotoStart
END;



{ Destructor done.
  Lscht alle Listenelemente wenn Liste nicht leer. }
DESTRUCTOR Liste.done;
BEGIN
     IF IsEmpty = false THEN
        clearList;
END;



BEGIN
END.