{ Unit:            token.pas
  Autor:           Sascha Nemecek
  Matrikelnr.:     9825815
  Erstellt am:     13.04.1999
  Letzte nderung: 19.04.1999

  Kurzbeschreibung:
  Ermglicht es einen String in mehrere Teilstrings aufzuteilen.
  Der Benutzer kann die Trennzeichen selbst auswhlen.
  Wird dem Tokenizer ein String bergeben so merkt er sich diesen und
  der Tokenizer kann so oft aufgerufen werden bis der String nicht mehr
  Teilbar ist. Die Trennzeichen knnen bei jedem Aufruf verndert werden.
  }


UNIT TOKEN;



INTERFACE

USES MagTools;


PROCEDURE tokenize (s: STRING; VAR d: STRING; tokens: STRING);




IMPLEMENTATION


VAR
   tokenindex: integer;
   tokenstring: STRING;
   tokenseperators: STRING;



{ Prozedur tokenize.
  Zeilt einen String. Der Benutzer kann die Trennzeichen bergeben.
  Beim ersten Aufruf der Prozedur mssen alle Werte bergeben werden.
  Dann kann die Prozedur so lange aufgerufen werden, bis der String
  nicht weiter zerlegbar ist.
  @param s Der zu teilende String.
  @param d Der gefundene Teilstring.
  @param tokens Die Trennzeichen. }
PROCEDURE tokenize (s: STRING; VAR d: STRING; tokens: STRING);
VAR i, start, ende: integer;
    fund: boolean;
BEGIN
   IF length (s) > 0 THEN BEGIN
      tokenindex := 1;
      tokenstring := s;
   END;

   { Wenn neue Trennzeichen bergeben wurden, die alten ersetzen. }
   IF length (tokens) > 0 THEN
      tokenseperators := tokens;

   fund := TRUE;

   { Beginn des nchsten Tokens suchen. }
   WHILE fund=TRUE DO BEGIN
      fund := FALSE;
      FOR i := 1 TO length (tokenseperators) DO
         IF s[tokenindex] = tokenseperators[i] THEN
            fund := TRUE;

      IF fund = TRUE THEN inc (tokenindex);
      IF tokenindex > (length (tokenstring)) THEN fund := FALSE
   END;
   start := tokenindex;

   fund := FALSE;

   { Ende des Tokens suchen. }
   WHILE fund=FALSE DO BEGIN
      FOR i := 1 TO length (tokenseperators) DO
         IF s[tokenindex] = tokenseperators[i] THEN
            fund := TRUE;

      IF tokenindex > (length (tokenstring)) THEN fund := TRUE;
      IF fund = FALSE THEN inc (tokenindex);
   END;
   ende := tokenindex;

   IF start = ende THEN
      D[0] := #0
   ELSE
      strincpy (d, tokenstring, start, (ende-start-1));
END;



BEGIN
END.